"use strict";

var currentlyPlaying = false;
var currentlyPlayingMedia = null;
var mediaTimer = null;

function togglePlayAudio(id, url) {

  var playListItem = $j("#playlistitem-"+id);
  var progressBarItem = $j("#progressbaritem-"+id);
  var playPauzeButton = $j("#playpauzebutton-"+id);

  function onPlayerSuccess() {
  }

  function onPlayerError(e) {
    // TODO console log
    console.log("media playback error: " + JSON.stringify(e));
  }

  function onMediaStatus(status) {
    if (status == Media.MEDIA_RUNNING) {
      playPauzeButton.attr('src', 'img/button-pauze.png');
      $j("li.playlistitem").removeClass("now-playing");
      playListItem.addClass("now-playing");
      currentlyPlaying = true;
    } else {
      playPauzeButton.attr('src', 'img/button-play.png');
      currentlyPlaying = false;
    }
  }

  // the play button was clicked this session
  if (currentlyPlayingMedia != null) {
    // the pause button was hit
    if (currentlyPlayingMedia.src == url) {
      if (currentlyPlaying) {
        currentlyPlayingMedia.pause();
//        playPauzeButton.attr('src', 'img/button-play.png');
      } else {
//        playPauzeButton.attr('src', 'img/button-pauze.png');
        currentlyPlayingMedia.play();
      }
    } else {
      // the play button of a different track was clicked, so hide all progressbars and swap the button img
      $j(".progressbar img").css({'visibility':'hidden'});
      currentlyPlayingMedia.stop();
    }
  }

  if (currentlyPlayingMedia == null || currentlyPlayingMedia.src != url) {
    currentlyPlayingMedia = new Media(
        url,
        onPlayerSuccess,
        onPlayerError,
        onMediaStatus);

//    currentlyPlayingMedia.play({ playAudioWhenScreenIsLocked : true /* doesn't seem to work on iOS */ });
    currentlyPlayingMedia.play();
//    playPauzeButton.attr('src', 'img/button-pauze.png');

//    setTimeout(function() {
//      duration = currentlyPlayingMedia.getDuration();
//    }, 500);
  }

  // Update media position every second
  if (mediaTimer != null) {
    clearInterval(mediaTimer);
  }
  mediaTimer = setInterval(function () {
    // get media position
    currentlyPlayingMedia.getCurrentPosition(
        // success callback
        function (position) {
          if (position > -1) {
            var duration = currentlyPlayingMedia.getDuration();
            var movePixels = (window.innerWidth - 32) / duration;
            progressBarItem.css({'visibility': 'visible', 'margin-left': (movePixels * position)+'px'});
          }
        },
        // error callback
        function (e) {
          document.getElementById("test").value="Error getting pos=" + e;
        }
    );
  }, 500);
}
