"use strict";
var $j = jQuery;

var textarea_height = 100;
var MAX_TOPICS_PER_FETCH = 15;
var refreshHome = true;
var refreshForumIndex = false;
var openPanelID = null;

var month_01 = 'jan';
var month_02 = 'feb';
var month_03 = 'maa';
var month_04 = 'apr';
var month_05 = 'mei';
var month_06 = 'jun';
var month_07 = 'jul';
var month_08 = 'aug';
var month_09 = 'sep';
var month_10 = 'okt';
var month_11 = 'nov';
var month_12 = 'dec';

var day_0 = 'zondag';
var day_1 = 'maandag';
var day_2 = 'dinsdag';
var day_3 = 'woensdag';
var day_4 = 'donderdag';
var day_5 = 'vrijdag';
var day_6 = 'zaterdag';

// generic catch for errors
window.onerror = function (o, file, line) {
  var cache = [];
  alert('Error gevangen: ' + file + ':' + line + '\n' + JSON.stringify(o, function (key, value) {
    if (typeof value === 'object' && value !== null) {
      if (cache.indexOf(value) !== -1) {
        // Circular reference found, discard key
        return;
      }
      // Store value in our collection
      cache.push(value);
    }
    return value;
  }));
  cache = null; // preserving memory
};

function isAndroid() {
  return navigator.userAgent.toLowerCase().indexOf("android") > -1;
}

function isAndroid2() {
  return navigator.userAgent.toLowerCase().indexOf("android 2") > -1;
}

function isIOS() {
  return navigator.userAgent.match(/(iPad|iPhone|iPod)/i);
}

function isMobile() {
  return isIOS() || isAndroid();
}

function onDeviceReady() {

  if (isIOS()) {
    StatusBar.backgroundColorByName("white");
    StatusBar.styleDefault();
    StatusBar.overlaysWebView(false);
  }

  document.addEventListener("backbutton", onBackButtonPressed, false);

  // make sure the app never falls asleep
  window.plugins.insomnia.keepAwake(function(a) {console.log('keepAwake success: ' + a)}, function(b) {console.log('keepAwake error: ' + b)});

  // avoid a white screen when the splashscreen is hidden on Android
  setTimeout(function() {
    navigator.splashscreen.hide();
  }, isAndroid() ? 1500 : 0);
}

// The Android backbutton should just do the same as clicking the backbutton in the header (with some added sugar for closing the menu)
function onBackButtonPressed() {
  if (openPanelID != null) {
    $j('#'+openPanelID).panel("close");
  } else {
    var currentPage = $j.mobile.activePage[0].id;
    if (currentPage == "homePage" || currentPage == "loginPage") {
      navigator.app.exitApp();
    } else {
      $j('#' + currentPage)
          .find('.backbutton')
          .trigger('click');
    }
  }
}

function onResume() {
  // refresh the homepage on resume
  refreshHome = true;
  // if we're currently on the homepage, make sure it's refreshed by triggering a transition
  if ($j.mobile.activePage[0].id == "homePage") {
    $j.mobile.changePage($j("#homePage"), {transition: "none", allowSamePageTransition: true});
  }
}

function getServiceURL(servicePath) {
  // on a device, connect to the testserver, otherwise to the dev machine
  var fullServicePath = "/" + appLanguage + "/api/" + apiVersion;
  if (true || isMobile()) {
    return apiUrl + fullServicePath + servicePath;
  } else {
    // strip any params from the path
    if (servicePath.indexOf('?') > -1) {
      servicePath = servicePath.substring(0, servicePath.indexOf('?'));
    }
    return "serverstub" + fullServicePath + servicePath + ".json";
  }
}

/**
 * Sommige Androidversies geven 'illegal date' voor new Date ("2013-02-20T14:49:27TZD")
 * Daarom eigen functie gemaakt 
 */
function getDate(dateString /* 2013-02-20T14:49:27TZD */) {
	var y = dateString.substring(0, 4);
  var m = dateString.substring(5, 7);
  var d = dateString.substring(8, 10);
  return new Date(y, m - 1, d);
}

/**
 * Indien vandaag: toon uren en minuten, bv '15:34'
 * Zo nee, indien gisteren: toon 'gisteren'
 * Zo nee, indien < 7 dagen geleden: toon de dag, bv 'donderdag'
 * Zo nee, indien dit jaar: toon de datum, bv '31 aug'
 * Zo nee: toon datum en jaar, bv '31 aug 2012'
 * @param dateString
 * @return {string}
 */
function getDateString(dateString /* 2013-02-20T14:49:27TZD */) {
  var compareDate = getToday();

	var y = dateString.substring(0, 4);
  var m = dateString.substring(5, 7);
  var d = dateString.substring(8, 10);

  var theDate = getDate(dateString);
  var theTime = theDate.getTime();

  // check for today
  if (theTime == compareDate.getTime()) {
    var h = dateString.substring(11, 13);
    var min = dateString.substring(14, 16);
    return h + ":" + min;
  }

  // check for yesterday
  compareDate.setDate(compareDate.getDate() - 1);
  if (theTime == compareDate.getTime()) {
    return "gisteren";
  }

  // check for this week
  compareDate.setDate(compareDate.getDate() - 6); // already subtracted one day
  if (theTime > compareDate.getTime()) {
    return getDayName(theDate.getDay());
  }

  // check for this year
  if (y == compareDate.getYear()) { // last weeks year is fine
    return d + " " + getMonthName(m);
  }

  // sometime before this year
  return d + " " + getMonthName(m) + " " + y;
}

function getMonthName(monthNumber) {
  return eval("month_" + monthNumber);
}

function getDayName(dayNumber) {
  return eval("day_" + dayNumber);
}

function getToday() {
  var today = new Date();
  today.setHours(0);
  today.setMinutes(0);
  today.setSeconds(0);
  today.setMilliseconds(0);
  return today;
}

function getPersonPhotoUrl(url) {
  // TODO ask DJ to send 70x70 personimages to the client
  return url == null ? "img/app/avatar.png" : url;
}
function getUserProfileUrl (user) {
  var fromPageUrl = '#' + $j.mobile.activePage.attr('id');
  return '#userProfilePage?userId=' + user.id + '&fromPageUrl=' + escape(fromPageUrl);
}

function getFullName(user) {
  return user.firstname + ' ' + user.lastname;
}

function getUserImg (user) {
  return '<img class="user_thumb" onClick="document.location.href=\''+getUserProfileUrl(user)+'\'" src="' + getPersonPhotoUrl(user.photo_url) + '"/>'
}

function getRecipePhotoUrl(illustrations) {
  return illustrations.length == 0 ? "img/app/recipe_placeholder.png" : illustrations[0].photo_url;
}

function logout() {
  storeUser(null);
  setPassword(null);
}

function isLoggedIn() {
  return getUser() != null;
}

function configureSubscribeButton(element, url, isSubscribed) {
  $j(element)
      .val(isSubscribed ? 'Zeg e-mail abonnement op' : 'Abonneer per e-mail')
      .button('refresh')
      .unbind('click')
      .bind('click', function () {
        var that = $j(this);
        invokeRemote(
            isSubscribed ? 'DELETE' : 'POST',
            getServiceURL(url),
            null,
            true,
            function (data) {
              showAlert("Opslaan gelukt", "Je instelling is opgeslagen.");
              configureSubscribeButton(element, url, !isSubscribed);
            });
      });
}

function doPost(url, data, async, successFunction, errorFunction) {
  invokeRemote('POST', url, data, async, successFunction, errorFunction);
}

function doGet(url, async, successFunction, errorFunction) {
  invokeRemote('GET', url, null, async, successFunction, errorFunction);
}

function invokeRemote(method, url, data, async, successFunction, errorFunction) {
  var loginName = getLoginName();
  var password = getPassword();
  $j.ajax({
    type: method,
    headers: {
      "X-ECOACHING-EMAIL": btoa(loginName),
      "X-ECOACHING-PASSWORD": btoa(password)
    },
    url: url,
    cache:false,
    data: data,
    dataType: 'json',
    async: async,
    success: function (data) {
      successFunction(data);
    },
    error: function (XMLHttpRequest, textStatus, errorThrown) {
      if (errorFunction != null) {
        errorFunction();
      } else {
//        showAlert("Melding", "Service failed: " + url + ", " + textStatus + "; " + errorThrown);
        $j.mobile.changePage($j("#noNetworkPage"), {transition: "none"});
      }
    }
  });
}

function setLoginName(loginName) {
  localStorage.setItem("loginName", loginName);
}

function getLoginName() {
  return localStorage.getItem("loginName");
}

function setPassword(password) {
  localStorage.setItem("password", password);
}

function getPassword() {
  return localStorage.getItem("password");
}

function storeUser(obj) {
  return localStorage.setItem("user", JSON.stringify(obj));
}

function getUser() {
  var usr = localStorage.getItem("user");
  if (usr == null || usr == 'undefined') {
    return null;
  } else {
    return JSON.parse(usr);
  }
}

function back(toPageID) {
  $j.mobile.changePage(toPageID, {reverse: true});
}

function extractFilename(theURI) {
  return theURI.substring(theURI.lastIndexOf("/") + 1);
}

function rewriteAnchorsInsideElement(theElement) {
  $j(theElement)
      .find("a")
      .each(function (i, anchor) {
        $j(anchor)
            .attr('onclick', "openWindow(\'" + anchor.href + "\')") // links are rewritten to use the InAppBrowser API, via the openWindow function
            .attr('href', "#") // the href tag is replaced by a #
            .addClass('ui-link') // make sure the links have a nice look
        ;
      });
}

// not cool that the server sends inline scripts, so make sure they're disabled and also make sure the word 'script' can still be used
function deleteScript(content) {
  while (content.indexOf("script") > -1) {
    content = content.replace("script", "scr&shy;ipt");
  }
  return content;
}

function openWindow(pleaseTakeMeHere) {
  window.open(pleaseTakeMeHere, '_system');
}

function showAlert(title, txt) {
  if (isMobile()) {
    navigator.notification.alert(txt, function () {
    }, title);
  } else {
    alert(title + "\n\n" + txt);
  }
}

function showAlertWithCallback(title, txt, callback) {
  if (isMobile()) {
    navigator.notification.alert(txt, callback, title);
  } else {
    alert(title + "\n\n" + txt);
  }
}

function  loadHomepageHeader() {
  var pageName = "homePage";
  var menuPanelID = pageName + "_menupanelid";

  $j('#' + pageName + " .header")
      .attr('data-role', 'header')
      .attr('data-tap-toggle', 'false')
      .attr('data-position', 'fixed')
      .html(
          '<div id="homePageLogoContainer"><img src="img/app/logo_header.png" height="30"/></div>' +
          '<div class="subheader"></div>'
      );

//  addMenuToPage(pageName, menuPanelID);
}
// executed one time per page (pagebeforecreate)
function loadHeader(pageName, addMenu, h1, backHref) {
  var menuPanelID = pageName + "_menupanelid";

  $j('#' + pageName + " .header")
      .attr('data-role', 'header')
      .attr('data-tap-toggle', 'false')
      .attr('data-position', 'fixed')
      .html((!backHref ? '' : '  <a class="backbutton" data-mini="true" href="' + backHref + '" data-icon="arrow-l" data-direction="reverse" class="button_back">Terug</a>') +
          '  <h1>' + h1 + '</h1>' +
          (!addMenu ? '' : '<a data-icon="bars" data-iconpos="right" data-mini="true" href="#' + menuPanelID + '" data-position-to="window" class="ui-btn-right">Menu</a>') +
//          (!addMenu ? '' : '<div class="menuButtonContainer"><img src="../img/category.png" height="20px" data-menupanelid="'+menuPanelID+'" id="' + menuPanelID + '_button" class="menuPanelButton"/></div>') +
          '      <div class="subheader"></div>');
}

function parseDateYYYYMMDD(dateString, separator) {
  var parts = dateString.split(separator);
  return new Date(parts[0], parts[1] - 1, parts[2]);
}

function parseDateDDMMYYYY(dateString, separator) {
  var parts = dateString.split(separator);
  return new Date(parts[2], parts[1] - 1, parts[0]);
}

// formats a javascript date object to yyyy-mm-dd
function formatDate(date) {
  var curr_date = date.getDate();
  var curr_month = date.getMonth() + 1; //Months are zero based
  if (curr_month < 10) {
    // Add prepending zero
    curr_month = "0" + curr_month;
  }
  var curr_year = date.getFullYear();
  return curr_date + "-" + curr_month + "-" + curr_year;
}

function getLastEnteredWeight(callback) {
  doGet(
      getServiceURL("/measurements/weight"),
      false,
      function (data) {
        var lastEnteredWeight = defaultWeight;
        if ($j(data.result.measurements).length > 0) {
          var mostRecentMeasurement = $j(data.result.measurements.last());
          lastEnteredWeight = mostRecentMeasurement[0].value;
        }
        callback(Math.floor(lastEnteredWeight)-4);
      });
}

function getTodaysEnteredWeight(callback) {
  doGet(
      getServiceURL("/measurements/weight"),
      true,
      function (data) {
        var today = getToday();
        var todaysValue = null;
        $j(data.result.measurements).each(function (measurementIdx, measurement) {
          var measurementDate = parseDateYYYYMMDD(measurement.created_on, "/");
          if (measurementDate >= today) {
            todaysValue = measurement.value;
          }
        });
        callback(todaysValue);
      });
}

function navigateToHomePage() {
  $j.mobile.changePage($j("#homePage"));
}

function removeTags(html) {
	return html.replace(/(<([^>]+)>)/ig,"");
}

function localiseNumber(number) {
  return number.toString().replace('.', ',');
}
